/**
* Vmbackup App
* There are different ways implementing an App
*/
var ConfigWizardApp = ConfigWizardApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
ConfigWizardApp.App = function () {
    this.id = 'ConfigWizardApp';
    this.name = 'Config Wizard';
    this.version = '6.0.27';
    this.active = false;
    this.menuIcon = '/apps/configwizard/images/logo.png?v=6.0.27&';
    this.shortcutIcon = '/apps/configwizard/images/logo.png?v=6.0.27&';
    this.entryUrl = '/apps/configwizard/configwizard.html?v=6.0.27&';
    var self = this;
    this.ConfigWizardAppWindow = function () { //create app window
        self.window=new MUI.Window({
            id: 'ConfigWizardAppWindow',
            title: UNAS._('U-NAS Config Wizard'),
            icon: '/apps/configwizard/images/logo_small.png?v=6.0.27&',
            width: 1170,
            height: 685,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [1170, 2000], 'y': [685, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/configwizard/configwizard.html?v=6.0.27&',
            require: {  css: [
              '/apps/configwizard/css/configwizard.css?v=6.0.27&',
              '/apps/configwizard/css/configwizardpublic.css?v=6.0.27&',
            ] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Config Wizard",'ConfigWizardAppWindow')},
            onClose:function(){
              jQuery('#jv-t_div').remove();
            }
        });
    };
    this.ConfigWizardAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('Config Wizard');
        UNAS.RemoveMenu('Config Wizard');
        UNAS.RemoveAppFromGroups('Config Wizard', 'ControlPanel');
        UNAS.RemoveAppFromGroups('Config Wizard', 'Help');
        UNAS.RemoveAppFromApps('Config Wizard');
    }
    new UNAS.Menu('UNAS_App_Accessories_Menu', this.name, this.menuIcon, 'Config Wizard', '', this.ConfigWizardAppWindow);
    //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Config Wizard', this.ConfigWizardAppWindow);
    //new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Config Wizard', UNAS._('Config Wizard')); //translate menu
        //UNAS.SetShortcutTitle('Vmbackup', UNAS._('Vmbackup')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            //need to translate the window title, menu and shortcut
            UNAS.SetWindowTitle('ConfigWizardAppWindow', UNAS._('Config Wizard'));
        }
    }
    UNAS.LoadTranslation('/apps/configwizard/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.ConfigWizardAppWindow,this.ConfigWizardAppUninstall);
};
ConfigWizard = new ConfigWizardApp.App(); //Create app
