function getAllGroupsInfo() {
  jQuery.ajax({
    url: "/apps/groupaccount/includes/services_groupaccount.php",
    type: "POST",
    async: true,
    dataType: 'json',
    data: {
      "action": "getallgroups"
    },
    timeout: 30000,
    success: function(data) {
      var groups = data || [];
      jQuery('#jv-groupachost').empty();
      for (var i = 0; i < groups.length; i++) {
        var groupdata = groups[i];
        var groupdom = cwTemplateAppend('#jv-groupachost', 'jvt-groupitem', 'jvt-groupitem-' + i);
        groupdom.data('groupinfo', groupdata);
        groupdom.find('.unas_checkbox input').attr('id', 'sel-checkbox-' + i);
        groupdom.find('.unas_checkbox input').val(groupdata.name);
        groupdom.find('.unas_checkbox label').attr('for', 'sel-checkbox-' + i);
        if (groupdata.name == "Administrators") {
          groupdom.find('.cw-edit-grouppermission').remove();
          groupdom.find('.cw-del-group').remove();
          groupdom.find('.unas_checkbox input').prop('checked', true);
          belonggroup = groupdata.name;
        }
        if (groupdata.name == "everyone") {
          groupdom.find('.cw-del-group').remove();
        }
        groupdom.find('.groupname').text(cwgroupCutStr(groupdata.name, 24)).attr('title', groupdata.name);
        groupdom.find('.groupcomment').text(cwgroupCutStr(groupdata.comment, 24)).attr('title', groupdata.comment);
        groupdom.find('.grouplocal').text(UNAS._("Local"));

        //编辑用户组
        groupdom.find('.cw-edit-groupinfo').on('click', function() {
          var c_groupinfo = jQuery(this).closest('tr.groupitem').data('groupinfo');
          editGroupInfo(c_groupinfo);
        });
        //编辑用户权限
        groupdom.find('.cw-edit-grouppermission').on('click', function() {
          var c_groupinfo = jQuery(this).closest('tr.groupitem').data('groupinfo');
          modifyGroupPrivilege(c_groupinfo);
        });
        //删除用户组
        groupdom.find('.cw-del-group').on('click', function() {
          var c_groupinfo = jQuery(this).closest('tr.groupitem').data('groupinfo');
          deleteGroup(c_groupinfo);
        });
      }

      jQuery('#jv-groupachost :checkbox[type="checkbox"]').each(function() {
        jQuery(this).on('click', function() {
          if (jQuery(this).prop('checked')) {
            jQuery('#jv-groupachost :checkbox[type="checkbox"]').removeAttr('checked');
            jQuery(this).prop('checked', 'checked');
            jQuery("#jv-addgroup-enter").attr("class", "unas_button_sub");
            belonggroup = jQuery(this).val();
          } else {
            jQuery("#jv-addgroup-enter").attr("class", "unas_button_sub_disabled");
          }
        });
      });

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function addGroup() {
  var AddGroupWindow = new MUI.Modal({
    id: 'AddGroupWindow',
    title: UNAS._('Add Group'),
    contentURL: '/apps/configwizard/homes/addgroup.html?v=6.0.27&',
    // modal: true
    type: 'modal2',
    modalOverlayClose: false,
    width: 500,
    height: 250,
  });
  AddGroupWindow.ProcessAddGroup = function() {
    getAllGroupsInfo();
  }
  jQuery(AddGroupWindow.windowEl).addClass('modal-t-2').css('height','280px');
}

//编辑用户组
function editGroupInfo(groupInfo) {
  var groupname = groupInfo.name;
  var gidnumber = groupInfo.gid;
  var EditGroupInfoWindow = new MUI.Modal({
    id: 'EditGroupInfoWindow',
    title: UNAS._('Edit Group Information'),
    contentURL: '/apps/configwizard/homes/editgroupinfo.html?v=6.0.27&gid=' + gidnumber + '&name=' + groupname,
    width: 500,
    height: 250,
    modalOverlayClose: false,
    // modal: true
    type: 'modal2'
  });
  EditGroupInfoWindow.ProcessEditGroupInfo = function() {
    getAllGroupsInfo();
  }
  jQuery(EditGroupInfoWindow.windowEl).addClass('modal-t-2').css('height','280px');
}

//编辑用户权限
function modifyGroupPrivilege(groupInfo) {
  var groupname = groupInfo.name;
  var ModifyGroupPrivilegeWindow = new MUI.Modal({
    id: 'ModifyGroupPrivilegeWindow',
    title: UNAS._('Modify Group Privilege'),
    contentURL: '/apps/configwizard/homes/groupprivilege.html?v=6.0.27&groupname=' + groupname,
    width: 600,
    height: 400,
    modalOverlayClose: false,
    // modal: true
    type: 'modal2'
  });
  ModifyGroupPrivilegeWindow.ProcessModifyGroupPrivilege = function() {
    getAllGroupsInfo();
  }
  jQuery(ModifyGroupPrivilegeWindow.windowEl).addClass('modal-t-2').css('height','430px');
}

//删除用户组
function deleteGroup(groupInfo) {
  var groupname = groupInfo.name;
  var gidnumber = groupInfo.gid;
  var DelGroupWindow = new MUI.Modal({
    id: 'DelGroupWindow',
    title: UNAS._('Delete Group'),
    contentURL: '/apps/configwizard/homes/deletegroup.html?v=6.0.27&gid=' + gidnumber + '&name=' + groupname,
    // modal: true
    type: 'modal2',
    modalOverlayClose: false,
    width: 400,
    height: 200
  });
  DelGroupWindow.ProcessDelGroup = function() {
    getAllGroupsInfo();
  }
  jQuery(DelGroupWindow.windowEl).addClass('modal-t-2').css('height','230px');
}
