function getuserlistall() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/apps/useraccount/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode({
        cmd: "user_list_all",
        token: UToken
      }),
      dataType: 'json',
      contentType: 'application/json',
      success: function(result) {
        if (result.err == 0) {
          var homesInfo = result.results || {};
          ConfigWizardInfo.homesInfo = homesInfo;
          refreshuserlist(homesInfo);
        } else {
          refreshuserlist(ConfigWizardInfo.homesInfo);
        }
        if (fy) {
          configwizardTranslator('jv-user-host');
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {

      }
    });
  })

}

//用户信息列表
function refreshuserlist(userinfo) {
  var current_user = userinfo.current_user;
  jQuery('#jv-user-host').html('');
  for (var i = 0; i < userinfo.users.length; i++) {
    var userdata = userinfo.users[i];
    var userdom = cwTemplateAppend('#jv-user-host', 'jvt-cw-useritem', 'jvt-cw-useritem-' + i);
    userdom.data('userinfo', userdata);
    var type = userdata.name.indexOf("\\") == -1 ? "Local" : "AD";
    userdom.find('.type').text(userdata.type);
    userdom.find('.username').text(userdata.name);
    userdom.find('.comment').text(userdata.comment || 'No description');
    if (userdata.name == 'admin') {
      userdom.find('.usericon').attr('src', '/apps/configwizard/images/guide_user_admin.png?v=6.0.27&');
      userdom.find('.cw-user-edit-permission').remove();
    } else {
      userdom.find('.usericon').attr('src', '/apps/configwizard/images/guide_user_normal.png?v=6.0.27&');
    }
    if (userdata.name == 'admin' && userdata.name == current_user) {
      userdom.find('.cw-user-del-user').remove();
    }
    if (userdata.sudoer) {
      userdom.find('.sudoer').attr('src', '/apps/configwizard/images/guide_selected.png?v=6.0.27&');
    } else {
      userdom.find('.sudoer').attr('src', '/apps/configwizard/images/guide_noselected.png?v=6.0.27&');
    }
    userdom.find('.sudoer').attr('sel', userdata.sudoer).attr('username', userdata.name).
    attr('onclick', 'checkUser_sudoer_cw()');
    userdom.find('.webaccess').attr('sel', userdata.webaccess).attr('username', userdata.name).
    attr('onclick', 'checkUserAllandDisabledWeb_cw()');
    if (userdata.webaccess) {
      if (userdata.name == 'admin') {
        userdom.find('.webaccess').attr('src', '/apps/configwizard/images/guide_selected_none.png?v=6.0.27&').css('pointer-events', 'none');
      } else {
        userdom.find('.webaccess').attr('src', '/apps/configwizard/images/guide_selected.png?v=6.0.27&');
      }
    } else {
      userdom.find('.webaccess').attr('src', '/apps/configwizard/images/guide_noselected.png?v=6.0.27&');
    }

    // 编辑密码
    userdom.find('.cw-user-edit-pwd').on('click', function() {
      var c_userinfo = jQuery(this).closest('li.useritem').data('userinfo');
      editUserPassword(c_userinfo);
    })
    //编辑用户信息
    userdom.find('.cw-user-edit-userinfo').on('click', function() {
      var c_userinfo = jQuery(this).closest('li.useritem').data('userinfo');
      editUserInfo(c_userinfo);
    })
    //编所属用组
    userdom.find('.cw-user-edit-usergroup').on('click', function() {
      var c_userinfo = jQuery(this).closest('li.useritem').data('userinfo');
      editUserGroupMember(c_userinfo);
    })
    //更改用户权限
    userdom.find('.cw-user-edit-permission').on('click', function() {
      var c_userinfo = jQuery(this).closest('li.useritem').data('userinfo');
      modifyUserPrivilege(c_userinfo);
    })
    // 删除用户
    userdom.find('.cw-user-del-user').on('click', function() {
      var c_userinfo = jQuery(this).closest('li.useritem').data('userinfo');
      delUser(c_userinfo);
    })
  }

  jQuery("#jv-user-content").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
}
//添加用户
function adduser() {
  var AddUserWindow = new MUI.Modal({
    id: 'AddUserWindow',
    title: UNAS._('Add User'),
    contentURL: '/apps/configwizard/homes/adduser.html?v=6.0.27&',
    modalOverlayClose: false,
    width: 800,
    height: 470,
    // modal: true
    type: 'modal2'
  });
  AddUserWindow.ProcessAddUser = function() {
    getuserlistall().then(function() {
      configwizardTranslator('jv-user-host');
    });
  };
  jQuery(AddUserWindow.windowEl).addClass('modal-t-2').css('height','500px');
}
// 编辑密码
function editUserPassword(userinfo) {
  var username = userinfo.name;
  var uidnumber = userinfo.uid;
  var EditUserPasswordWindow = new MUI.Modal({
    id: 'EditUserPasswordWindow',
    title: UNAS._('Edit User Password'),
    contentURL: '/apps/configwizard/homes/edituserpassword.html?v=6.0.27&uid=' + uidnumber + '&name=' + username,
    modalOverlayClose: false,
    width: 460,
    height: 260,
    // modal: true
    type: 'modal2'

  });
  EditUserPasswordWindow.ProcessEditUserPassword = function() {
    getuserlistall();
  };
  jQuery(EditUserPasswordWindow.windowEl).addClass('modal-t-2').css('height','290px');
}
//编辑用户信息
function editUserInfo(userinfo) {
  var username = userinfo.name;
  var uidnumber = userinfo.uid;
  var EditUserInfoWindow = new MUI.Modal({
    id: 'EditUserInfoWindow',
    title: UNAS._('Edit User Information'),
    contentURL: '/apps/configwizard/homes/edituserinfo.html?v=6.0.27&uid=' + uidnumber + '&name=' + username,
    modalOverlayClose: false,
    width: 460,
    height: 290,
    // modal: true
    type: 'modal2'
  });
  EditUserInfoWindow.ProcessEditUserInfo = function() {
    getuserlistall();
  };
  jQuery(EditUserInfoWindow.windowEl).addClass('modal-t-2').css('height','320px');
}
//编所属用组
function editUserGroupMember(userinfo) {
  var username = userinfo.name;
  var uidnumber = userinfo.uid;
  var EditUserGroupMemberWindow = new MUI.Modal({
    id: 'EditUserGroupMemberWindow',
    title: UNAS._('Edit Group Member'),
    contentURL: '/apps/configwizard/homes/editusergroupmember.html?v=6.0.27&uid=' + uidnumber + '&name=' + username,
    modalOverlayClose: false,
    width: 800,
    height: 470,
    // modal: true
    type: 'modal2'
  });
  EditUserGroupMemberWindow.ProcessEditUserGroupMember = function() {
    getuserlistall().then(function() {
      // configwizardTranslator('jv-user-host');
    });
  };
  jQuery(EditUserGroupMemberWindow.windowEl).addClass('modal-t-2').css('height','500px');
}

//更改用户权限
function modifyUserPrivilege(userinfo) {
  var username = userinfo.name;
  var uidnumber = userinfo.uid;
  var ModifyUserPrivilegeWindow = new MUI.Modal({
    id: 'ModifyUserPrivilegeWindow',
    title: UNAS._('Modify User Privilege'),
    contentURL: '/apps/configwizard/homes/privilege.html?v=6.0.27&username=' + username,
    modalOverlayClose: false,
    width: 800,
    height: 470,
    // modal: true
    type: 'modal2'
  });
  ModifyUserPrivilegeWindow.ProcessEditUser = function() {
    getuserlistall();
  };
  jQuery(ModifyUserPrivilegeWindow.windowEl).addClass('modal-t-2').css('height','500px');
}

// 删除用户
function delUser(userinfo) {
  var username = userinfo.name;
  var uidnumber = userinfo.uid;
  var DelUserWindow = new MUI.Modal({
    id: 'DelUserWindow',
    title: UNAS._('Delete User'),
    contentURL: '/apps/configwizard/homes/deleteuser.html?v=6.0.27&uid=' + uidnumber + '&name=' + username,
    modalOverlayClose: false,
    // modal: true
    type: 'modal2',
    width: 430,
    height: 230,
  });
  DelUserWindow.ProcessDelUser = function() {
    getuserlistall();
  };
  jQuery(DelUserWindow.windowEl).addClass('modal-t-2').css('height','260px');
}
// 勾选
function checkboximg() {
  var ev = window.event || arguments.callee.caller.arguments[0];
  ev.stopPropagation();
  var t = jQuery(ev.target);
  if (jQuery(ev.target)[0].tagName != 'IMG') {
    return;
  }
  // if (parseInt(t.attr('sel'))) {
  //   t.attr('src', '/apps/configwizard/images/guide_noselected.png?v=6.0.27&');
  //   t.attr('sel', '0');
  //
  // } else {
  //   t.attr('src', '/apps/configwizard/images/guide_selected.png?v=6.0.27&');
  //   t.attr('sel', '1');
  //
  // }
}
// 点击选中之后调用sudoer
function checkUser_sudoer_cw() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = jQuery(event.target);

  if (parseInt(t.attr('sel'))) {
    t.attr('src', '/apps/configwizard/m/images/guide_noselected.png?v=6.0.27&');
    t.attr('sel', '0');
  } else {
    t.attr('src', '/apps/configwizard/m/images/guide_selected.png?v=6.0.27&');
    t.attr('sel', '1');
  }

  let sudoer = 1;
  let name = t.attr('username');

  sudoer = +t.attr('sel') ? 1 : 0;

  jQuery.ajax({
    url: '/apps/useraccount/includes/index.php',
    dataType: 'json',
    type: 'post',
    contentType: 'application/json',
    data: JSON.stringify({
      "cmd": "user_sudoer",
      "token": UToken,
      "params": {
        "username": name,
        "sudoer": sudoer
      }
    }),
    success: function(data) {
      // 0 一切正常/9972 不能对自己执行/9999 失败
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }

  });

};

// 点击选中之后调用webaccess
function checkUserAllandDisabledWeb_cw() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = jQuery(event.target);
  if (parseInt(t.attr('sel'))) {
    t.attr('src', '/apps/configwizard/m/images/guide_noselected.png?v=6.0.27&');
    t.attr('sel', '0');
  } else {
    t.attr('src', '/apps/configwizard/m/images/guide_selected.png?v=6.0.27&');
    t.attr('sel', '1');
  }

  let access = 1;
  let name = t.attr('username');
  access = +t.attr('sel') ? 1 : 0;

  jQuery.ajax({
    url: '/apps/useraccount/includes/index.php',
    dataType: 'json',
    type: 'post',
    contentType: 'application/json',
    data: JSON.stringify({
      "cmd": "user_webaccess",
      "token": UToken,
      "params": {
        "username": name,
        "access": access
      }
    }),
    success: function(data) {
      // 0 一切正常/9972 不能对自己执行/9999 失败
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }

  });

};
