var cw_currentIndex = 0;
var templvs = [];

function lvm2_alload(v) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/apps/lvm/include/lvm_fun.php",
      type: "POST",
      async: true,
      data: {
        "action": "get_vgsinfo"
      },
      dataType: 'json',
      // contentType: "application/json; charset=utf-8",
      success: function(data) {

        if (data) {
          var res = {};

          for (var i = 0; i < data.length; i++) {
            res[data[i].name] = data[i];

            var lvs = {};
            if (data[i].lvs.length) {
              for (var j = 0; j < data[i].lvs.length; j++) {
                lvs[data[i].lvs[j].name] = data[i].lvs[j];
              }
              res[data[i].name].lvs = lvs;
            } else {
              res[data[i].name].lvs = {};
            }

          }
          refreshRaid(res);
          resolve(res);

        } else {
          refreshRaid(ConfigWizardInfo.raidInfo.vgs);
        }

      },
      complete: function(XMLHttpRequest, status) {

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }).then(function(res) {
    var mounted = 0;
    for (var v in res) {
      if (res.hasOwnProperty(v)) {
        for (var g in res[v].lvs) {
          if (res[v].lvs.hasOwnProperty(g)) {
            if (res[v].lvs[g].mount) {
              mounted = 1;
            }
          }
        }
      }
    }
    if (mounted) {
      jQuery('#jv-next').removeClass('disabledBtn');
    } else {
      jQuery('#jv-next').addClass('disabledBtn');
    }

  })

}

function refreshRaid(vgs) {
  var islvs = 0;
  if (jQuery.isEmptyObject(vgs)) {
    jQuery('#jv-raid-content-null').show();
    jQuery('#jv-raid-content').hide();
  } else {
    jQuery('#jv-raid-content').show();
    jQuery('#jv-raid-content-null').hide();
    jQuery('#jv-cw-vg-list').empty();
    var i = 0;
    for (var v in vgs) {
      if (vgs.hasOwnProperty(v)) {
        var vginfo = vgs[v]
        var cachedata = null;
        var vgsdom = cwTemplateAppend('#jv-cw-vg-list', 'jvt-cw-vg-item', 'jvt-cw-vg-item-' + v + i);
        vgsdom.data('vginfo', vginfo);
        if (i == cw_currentIndex) {
          vgsdom.find('.lvlistcontent').show();
          vgsdom.find('.vg-arrow').removeClass('arrow_right').addClass('arrow_down');
        };
        vgsdom.find('.cw-vg-name').html(vginfo.name);
        vgsdom.find('.cw-vg-free').html(cwformSize(vginfo.free * 1024 * 1024));
        vgsdom.find('.cw-vg-capacity').html(cwformSize(vginfo.size * 1024 * 1024));

        vgsdom.find('.vg-arrow').on('click', function() {
          var pNode = jQuery(this).closest('div.cw-vg-item');
          if (jQuery(this).hasClass('arrow_right')) {
            jQuery(this).removeClass('arrow_right').addClass('arrow_down');
            pNode.find('.lvlistcontent').show();
          } else {
            jQuery(this).removeClass('arrow_down').addClass('arrow_right');
            pNode.find('.lvlistcontent').hide();
          }
          cw_currentIndex = jQuery('.vg-arrow').index(jQuery(this));
        });
        vgsdom.find('.op-vg-edit-btn').on('click', function() {
          var pNode = jQuery(this).closest('div.cw-vg-item');
          var c_vginfo = pNode.data('vginfo');
          editVgWindowFun(c_vginfo);
        });

        vgsdom.find('.op-vg-del-btn').on('click', function() {
          var pNode = jQuery(this).closest('div.cw-vg-item');
          var c_vginfo = pNode.data('vginfo');

          deleteVgWindowFun(c_vginfo);
        });

        if (!jQuery.isEmptyObject(vgs[v].lvs)) {
          vgsdom.find('.op-vg-del-btn').addClass('disabledBtn');
          islvs = 1;
        }

        for (var k in vgs[v].lvs) {
          if (vgs[v].lvs.hasOwnProperty(k)) {
            var lvinfo = vgs[v].lvs[k];
            var use = (((lvinfo.size / lvinfo.capacity) * 100).toFixed(2) || 0) + '%';
            var lvssdom = cwTemplateAppend(vgsdom.find('.cw-lv-list'), 'jvt-cw-lv-item', 'jvt-cw-lv-item-' + k);
            lvssdom.data('lvinfo', lvinfo);
            lvssdom.find('.cw-lv-name').html(lvinfo.name);
            lvssdom.find('.cw-lv-free').html(lvinfo.dfinfo.avail);
            lvssdom.find('.cw-lv-capacity').html(lvinfo.dfinfo.size);
            lvssdom.find('.lv-used-size').css('width', lvinfo.dfinfo.use);

            if (lvinfo.fstype == "lun") {
              lvssdom.find('.islun').show();
              lvssdom.find('.nolun').hide();
              if (lvinfo.type == "thin") {
                lvssdom.find('.lvtype').text('##$@lvm@$##Thin LUN Device:##$@lvm@$##');
              } else {
                lvssdom.find('.lvtype').text('##$@lvm@$##LUN Device:##$@lvm@$##');
              }
            } else {
              lvssdom.find('.nolun').show();
              lvssdom.find('.islun').hide();
              if (lvinfo.type == "thin") {
                lvssdom.find('.lvtype').text('##$@lvm@$##Thin Volume:##$@lvm@$##');
              } else {
                lvssdom.find('.lvtype').text('##$@lvm@$##Volume:##$@lvm@$##');
              }
            }

            if (lvinfo.mount) {
              lvssdom.find('.mount').text('##$@lvm@$##Mounted##$@lvm@$##');
            } else {
              lvssdom.find('.mount').text('##$@lvm@$##Unmounted##$@lvm@$##').addClass('nomount');
              lvssdom.find('.cw-islvfree').hide();
            }
            lvssdom.find('.mount-' + lvinfo.mount).css('display', 'flex');
            //删除卷
            lvssdom.find('.cw-del-lv').on('click', function() {
              var pNode = jQuery(this).closest('div.cw-vg-item');
              var c_vginfo = pNode.data('vginfo');
              var pNode_lv = jQuery(this).closest('div.cw-lv-item');
              var c_lvinfo = pNode_lv.data('lvinfo');
              deleteLv_cw(c_vginfo, c_lvinfo);

            });

            //卸载卷
            lvssdom.find('.cw-uninstall-lv').on('click', function() {
              var pNode = jQuery(this).closest('div.cw-vg-item');
              var c_vginfo = pNode.data('vginfo');
              var pNode_lv = jQuery(this).closest('div.cw-lv-item');
              var c_lvinfo = pNode_lv.data('lvinfo');
              uninstallLv_cw(c_vginfo, c_lvinfo);
            });

            //挂载卷
            lvssdom.find('.cw-mount-lv').on('click', function() {
              var pNode = jQuery(this).closest('div.cw-vg-item');
              var c_vginfo = pNode.data('vginfo');
              var pNode_lv = jQuery(this).closest('div.cw-lv-item');
              var c_lvinfo = pNode_lv.data('lvinfo');
              mountLv_cw(c_vginfo, c_lvinfo);
            });

            lvssdom.find('.cw-edit-lv').attr('cachedata', cachedata || 'null');
            // 编辑卷
            lvssdom.find('.cw-edit-lv').on('click', function() {
              var pNode = jQuery(this).closest('div.cw-vg-item');
              var c_vginfo = pNode.data('vginfo');
              var pNode_lv = jQuery(this).closest('div.cw-lv-item');
              var c_lvinfo = pNode_lv.data('lvinfo');
              editLvWindowFun(c_vginfo, c_lvinfo, jQuery(this).attr('cachedata'));
            });

          }
        }
        if (vginfo.free > 32) {
          var addlvbtn = cwTemplateAppend(vgsdom.find('.cw-lv-list'), 'jvt-addlvbtn', 'jvt-addlvbtn-' + v + i);
          addlvbtn.on('click', function() {
            var pNode = jQuery(this).closest('div.cw-vg-item');
            var c_vginfo = pNode.data('vginfo');
            createlv(c_vginfo);
          })
        }

        i++;
      }
    }

  }

  if (islvs) {
    jQuery('#jv-next').removeClass('disabledBtn');
  } else {
    jQuery('#jv-next').addClass('disabledBtn');
  }

  configwizardTranslator('jv-cw-vg-list');
}


function creat_formating_cw(vgname, lvname) {
  var t = null;
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode({
      cmd: 'lvm2_lv_formating',
      token: UToken,
      params: {
        "vg": vgname,
        "lv": lvname
      }
    }),
    dataType: "json",
    timeout: 60000000,
    success: function(data) {
      if (!data.results.creating) {
        clearTimeout(t);
        lvm2_alload().then(function() {});
        loading_cw_hide();
      } else {
        t = setTimeout(function() {
          creat_formating_cw(vgname, lvname);
        }, 1000);

      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}


// 创建卷组
function createvg() {
  var createvgWindow = new MUI.Modal({
    id: 'jv-cw-createvgWindow',
    title: UNAS._('##$@lvm@$##Create Volume Group##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    modalOverlayClose: false,
    width: 804,
    height: 470,
    contentURL: '/apps/configwizard/raid/createvg.html?v=6.0.27&'
  });
  jQuery(createvgWindow.windowEl).addClass('modal-t-2').css('height','500px');
}
//编辑卷组
function editVgWindowFun(vginfo) {
  var vgname = vginfo.name;
  var vgsize = cwformSize(vginfo.size * 1024 * 1024);
  var vgfreesize = cwformSize(vginfo.free * 1024 * 1024);
  var EditVgW = new MUI.Modal({
    id: 'EditVgWindow',
    title: UNAS._('##$@lvm@$##Edit Volume Group##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    width: 804,
    height: 470,
    modalOverlayClose: false,
    contentURL: '/apps/configwizard/raid/editvg.html?v=6.0.27&vgname=' + vgname + '&vgsize=' + vgsize + "&vgfreesize=" + vgfreesize
  });
  EditVgW.ProcessEditVg = function() {
    lvm2_alload();
  }
  jQuery(EditVgW.windowEl).addClass('modal-t-2').css('height','500px');
}

// 创建卷
function createlv(vginfo) {
  var vg = vginfo.name;
  var capacity = vginfo.size;
  var free = vginfo.free;
  var CreateLvW = new MUI.Modal({
    id: 'CreateLvWindow',
    title: UNAS._('##$@lvm@$##Create Volume##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    width: 520,
    height: 600,
    modalOverlayClose: false,
    contentURL: '/apps/configwizard/raid/createlv.html?v=6.0.27&vgname=' + vg + '&vgsize=' + capacity + "&vgfreesize=" + free
  });
  CreateLvW.ProcessCreateLv = function() {
    lvm2_alload().then(function() {});
  }
  jQuery(CreateLvW.windowEl).addClass('modal-t-2').css('height','630px');
}

// 编辑卷
function editLvWindowFun(vginfo, lvinfo, cachedata) {
  var vgname = vginfo.name;
  var vgfreesize = vginfo.free;
  var lvname = lvinfo.name;
  var EditLvW = new MUI.Modal({
    id: 'EditLvWindow',
    title: UNAS._('##$@lvm@$##Edit Volume##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    width: 580,
    height: 500,
    modalOverlayClose: false,
    contentURL: '/apps/configwizard/raid/editlv.html?v=6.0.27&vgname=' + vgname + '&lvname=' + lvname + "&vgfreesize=" + vgfreesize + "&cachedata=" + cachedata
  });
  EditLvW.ProcessEditLv = function() {
    lvm2_alload();
  }
  jQuery(EditLvW.windowEl).addClass('modal-t-2').css('height','530px');
}
// 删除卷组
function deleteVgWindowFun(vginfo) {
  var vgname = vginfo.name;
  var DeleteVgW = new MUI.Modal({
    id: 'DeleteVgWindow',
    title: UNAS._('##$@lvm@$##Delete Volume Group##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    width: 430,
    height: 230,
    modalOverlayClose: false,
    contentURL: '/apps/configwizard/raid/deletevg.html?v=6.0.27&vgname=' + vgname
  });
  DeleteVgW.ProcessDeleteVg = function() {

    lvm2_alload();
  }
  jQuery(DeleteVgW.windowEl).addClass('modal-t-2').css('height','260px');
}


// 删除卷
function deleteLv_cw(vginfo, lvinfo) {
  var vg = vginfo.name;
  var lv = lvinfo.name;
  var lvtype = lvinfo.type;
  var crypt = lvinfo.crypt;

  var DeleteLvW = new MUI.Modal({
    id: 'DeleteLvWindow',
    title: UNAS._('##$@lvm@$##Delete Volume##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    width: 430,
    height: 230,
    modalOverlayClose: false,
    contentURL: '/apps/configwizard/raid/deletelv.html?v=6.0.27&vgname=' + vg + '&lvname=' + lv + '&lvtype=' + lvtype + '&crypt=' + crypt
  });

  DeleteLvW.ProcessDeleteLv = function() {

    lvm2_alload();
  }
  jQuery(DeleteLvW.windowEl).addClass('modal-t-2').css('height','260px');
}

// 卸载卷
function uninstallLv_cw(vginfo, lvinfo) {
  var vg = vginfo.name;
  var lv = lvinfo.name;
  var crypt = lvinfo.tags.indexOf("crypt"); // lvinfo.crypt;

  var UmountLvW = new MUI.Modal({
    id: 'UmountLvWindow',
    title: UNAS._('##$@lvm@$##Umount Volume##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    modalOverlayClose: false,
    width: 430,
    height: 230,
    contentURL: '/apps/configwizard/raid/umountlv.html?v=6.0.27&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
  });
  UmountLvW.ProcessUmountLv = function() {
    lvm2_alload();
  }
  jQuery(UmountLvW.windowEl).addClass('modal-t-2').css('height','260px');
}

// 挂载卷
function mountLv_cw(vginfo, lvinfo) {
  var vg = vginfo.name;
  var lv = lvinfo.name;
  var crypt = lvinfo.tags.indexOf("crypt");

  var MountLvW = new MUI.Modal({
    id: 'MountLvWindow',
    title: UNAS._('##$@lvm@$##Mount Volume##$@lvm@$##'),
    // modal: true,
    type: 'modal2',
    modalOverlayClose: false,
    width: 400,
    height: 220,
    contentURL: '/apps/configwizard/raid/mountlv.html?v=6.0.27&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
  });
  MountLvW.ProcessMountLv = function() {
    lvm2_alload();
  }
  jQuery(MountLvW.windowEl).addClass('modal-t-2').css('height','250px');
}

function errNotice(c) {
  var ErrNoticeWindow = new MUI.Modal({
    id: 'ErrNoticeWindow',
    title: UNAS._('Error prompt'),
    contentURL: "/apps/configwizard/raid/errnotice.html?v=6.0.27&c="+c,
    // modal: true,
    type: 'modal2',
    width: 400,
    height: 130,
  });
  ErrNoticeWindow.ProcessErrNotice = function(){
    lvm2_alload();
  }
  jQuery(ErrNoticeWindow.windowEl).addClass('modal-t-2').css('height','160px');
}
